package io.nisum.designpattern.employee.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Transient;
import org.springframework.data.relational.core.mapping.Column;
import org.springframework.data.relational.core.mapping.Table;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.concurrent.atomic.AtomicLong;

@Data
@NoArgsConstructor
@AllArgsConstructor
@ToString( exclude = "id" )
@Table( name = "employee")
public class Employee {

    @Id
    @Column(value = "ID")
    private long id;

    @Column(value = "organizationId")
    private long organizationId;

    @Column(value = "departmentId")
    private long departmentId;

    @NotNull( message = "Name shouldn't be null")
    @Size(min = 8, max = 128, message = "Name size should fall under 8 - 128")
    @Column(value = "name")
    private String name;

    @Column(value = "age")
    private int age;

    @NotNull( message = "Position shouldn't be null")
    @Size(min = 8, max = 128)
    @Column(value = "position")
    private String position;

}
