package io.nisum.designpattern.employee.service;

import io.nisum.designpattern.employee.dto.EmployeeDto;
import io.nisum.designpattern.employee.dto.EmployeePatchDto;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public interface EmployeeService {
    Flux<EmployeeDto> findAll();
    Mono<EmployeeDto> findById( long id );
    Mono<EmployeeDto> findByName( String name );
    Flux<EmployeeDto> findByDepartment( long departmentId );
    Flux<EmployeeDto> findByOrganization( long organizationId );
    Mono<EmployeeDto> save( Mono<EmployeeDto> employeeDto );
    Mono<EmployeeDto> update( long id, Mono<EmployeeDto> employeeDto );
    Mono<EmployeeDto> patch( long id, Mono<EmployeePatchDto> employeePatchDto );
    Mono<Void> delete( long id );
}
