package io.nisum.designpattern.organization.controller;

import io.nisum.designpattern.organization.dto.OrganizationDto;
import io.nisum.designpattern.organization.mapper.OrganizationMapper;
import io.nisum.designpattern.organization.mapper.impl.OrganizationMapperImpl;
import io.nisum.designpattern.organization.service.OrganizationService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/organizations")
public class OrganizationController {

    private static Logger logger = LoggerFactory.getLogger(OrganizationController.class);

    @Autowired
    OrganizationService organizationService;

    @PostMapping
    public OrganizationDto add( @RequestBody OrganizationDto organizationDto) {
        logger.info("Organization add: {}", organizationDto);
        return organizationService.add(organizationDto);
    }

    @GetMapping
    public List<OrganizationDto> findAll() {
        logger.info("Organization find: ");
        return organizationService.findAll();
    }

    @GetMapping("/{id}")
    public OrganizationDto findById( @PathVariable("id") long id) {
        logger.info("Organization find: id={}", id);
        return organizationService.findById(id);
    }

}
