package io.nisum.designpattern.organization.mapper.impl;

import io.nisum.designpattern.organization.dto.OrganizationDto;
import io.nisum.designpattern.organization.entity.Organization;
import io.nisum.designpattern.organization.mapper.OrganizationMapper;

import java.util.List;
import java.util.stream.Collectors;

public class OrganizationMapperImpl implements OrganizationMapper {
    @Override
    public Organization mapToEntity(OrganizationDto organizationDto) {
        Organization organization = new Organization();
        organization.setId( organizationDto.getId() );
        organization.setName( organizationDto.getName() );
        organization.setAddress( organizationDto.getAddress() );
        return organization;
    }

    @Override
    public OrganizationDto mapToDto(Organization organization) {
        OrganizationDto organizationDto = new OrganizationDto();
        organizationDto.setId( organization.getId() );
        organizationDto.setName( organization.getName() );
        organizationDto.setAddress( organization.getAddress() );
        return organizationDto;
    }

    @Override
    public List<Organization> convertOrganizationDtoListToOrganizationList(List<OrganizationDto> organizationDtoList) {
        return organizationDtoList.stream().map(this::mapToEntity).collect(Collectors.toList());
    }

    @Override
    public List<OrganizationDto> convertOrganizationListToOrganizationDtoList(List<Organization> organizationList) {
        return organizationList.stream().map(this::mapToDto).collect(Collectors.toList());
    }
}
