package io.nisum.designpattern.organization.service.impl;

import io.nisum.designpattern.organization.dto.OrganizationDto;
import io.nisum.designpattern.organization.entity.Organization;
import io.nisum.designpattern.organization.mapper.OrganizationMapper;
import io.nisum.designpattern.organization.mapper.impl.OrganizationMapperImpl;
import io.nisum.designpattern.organization.repo.OrganizationRepo;
import io.nisum.designpattern.organization.service.OrganizationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class OrganizationServiceImpl implements OrganizationService {

    private OrganizationMapper mapper = new OrganizationMapperImpl();

    @Autowired
    OrganizationRepo organizationRepo;

    @Override
    public OrganizationDto add(OrganizationDto organizationDto) {
        Organization organization = mapper.mapToEntity(organizationDto);
        return mapper.mapToDto(organizationRepo.save(organization));
    }

    @Override
    public List<OrganizationDto> findAll() {
        return mapper.convertOrganizationListToOrganizationDtoList(organizationRepo.findAll());
    }

    @Override
    public OrganizationDto findById(long id) {
        return mapper.mapToDto(organizationRepo.findById(id).get());
    }

}